Attribute VB_Name = "General"
Sub ClearPageBreaks()
Attribute ClearPageBreaks.VB_ProcData.VB_Invoke_Func = "P\n14"
'use this to remove annoying page break lines if you accidentally hit Ctrl+P

'hit Ctrl+Shift+P to run
    ActiveSheet.DisplayPageBreaks = False

End Sub

Sub ListNames()
Attribute ListNames.VB_ProcData.VB_Invoke_Func = "N\n14"
'use this to create a list of names, and/or upload name comments
'it will add a sheet or use existing one with your permission

Dim Wb As Workbook, Ws, WsN As Worksheet
Dim Nm As Name, Nms As Names, Tbl As ListObject
Dim c, r, ctr As Integer, HdrArr As Variant
Dim scope As String, formula1 As String, formula2 As String, formula3 As String
HdrArr = Array("Scope", "Name", "Refers to", "Comment", "Type", "Usage", "Scope check")

Application.ScreenUpdating = False
Set Wb = ActiveWorkbook
Set Nms = Wb.Names
If Nms.Count = 0 Then MsgBox "No names": Exit Sub

On Error GoTo AddSheet
Set WsN = ActiveWorkbook.Worksheets("Names")
On Error Resume Next

WsN.Select

'check if headers match
With Range("A1")
 HdrsMatch = True
 For ctr = 0 To UBound(HdrArr)
  HdrsMatch = HdrsMatch And (.Offset(0, ctr) = HdrArr(ctr))
 Next
End With

If HdrsMatch Then
 GoTo AskUpload
Else
 Select Case MsgBox("This sheet has incorrect headers. New sheet?" & vbCr & _
 "Yes=create new one (manage names manually)." & vbCr & _
 "No=clear and refill this sheet.", _
 vbYesNoCancel + vbQuestion + vbDefaultButton2, "Update Sheet")
  Case vbYes: GoTo AddSheet
  Case vbNo: GoTo UpdateSheet
  Case vbCancel: Exit Sub
 End Select
End If
Exit Sub

AskUpload:
Select Case MsgBox("Upload Name comments?", vbYesNoCancel + _
vbQuestion + vbDefaultButton2, "Name Comment Upload")
 Case vbYes: GoTo UploadComments
 Case vbNo:
 Case vbCancel: Exit Sub
End Select

AskUpdate:
Select Case MsgBox("New sheet?" & vbCr & _
"Yes=create new one (manage names manually)." & vbCr & _
"No=clear and refill this sheet.", _
vbYesNoCancel + vbQuestion + vbDefaultButton2, "Update Sheet")
 Case vbYes: GoTo AddSheet
 Case vbNo: GoTo UpdateSheet
 Case vbCancel: Exit Sub
End Select

UploadComments:
'upload comments from existing sheet
WsN.Range("B2").Select
For Each Nm In ActiveWorkbook.Names
 If Nm.Visible Then
  With Selection
   scope = .Offset(0, -1)
   If scope = "workbook" Then scope = ActiveWorkbook.Name
   If Nm.Name = .Value And Nm.Parent = scope Then Nm.Comment = .Offset(0, 2).Value
   .Offset(1, 0).Select
  End With
 End If
Next Nm
MsgBox "Name comments uploaded.", vbOKOnly, "Name Comment Upload"
GoTo AskUpdate

UpdateSheet:
'clear sheet and refill
Columns("A:Z").Delete
GoTo SetHeaders

AddSheet:
'add new sheet
Wb.Worksheets.Add After:=Sheets(Sheets.Count)
Set WsN = ActiveSheet
WsN.Name = "Names"

SetHeaders:
'set up headers
With WsN
For ctr = 0 To UBound(HdrArr)
  .Cells(1, ctr + 1) = HdrArr(ctr)
Next
End With
GoTo FillData

FillData:
'fill name data
WsN.Range("A2").Select
For Each Nm In Nms
 If Nm.Visible Then
   ctr = 0
   If Nm.Parent.Name = Wb.Name Then scope = "Workbook" Else: scope = Nm.Parent.Name
   With Selection
     ctr = ctr + 1: .Cells(1, ctr) = scope
     ctr = ctr + 1: .Cells(1, ctr) = Nm.Name
     ctr = ctr + 1: .Cells(1, ctr) = "'" & Nm.RefersTo
     ctr = ctr + 1: .Cells(1, ctr) = Nm.Comment
     .Offset(1, 0).Select
   End With
 End If
Next Nm

FormatTable:
'format the table
Range("A1").Select
Selection.CurrentRegion.Select
WsN.ListObjects.Add(xlSrcRange, Selection, , xlYes, , _
"TableStyleLight9").Name = "tblNames"
Columns("A:B").EntireColumn.AutoFit
Columns("C:D").ColumnWidth = 40
With Selection
 .VerticalAlignment = xlTop
 .WrapText = True
End With

DefineFormulas:
'add formula 1 to derive reference type
formula1 = "=IF(NOT(ISREF(INDIRECT(RIGHT([@[Refers to]],LEN([@[Refers to]])-1))))," & _
"""formula"",CHOOSE(SUM(COUNTIF([@[Refers to]],""*$*"")," & _
"COUNTIF([@[Refers to]],""*$*$*""))+1,""relative"",""hybrid"",""absolute""))"
    
'add formula 2 to count how many times the name is referred to by other names
formula2 = "=COUNTIF([Refers to],""*""&[@Name]&""*"")"

'add formula 3 to check global names that refer to local range
formula3 = "=IFERROR(IF([@Scope]=""Workbook"",MID([@[Refers to]],2," & _
"FIND(""!"",[@[Refers to]])-1),""""),"""")"

FillFormulas:
WsN.Range("E2").Select
ctr = 0
With Selection
 ctr = ctr + 1: .Cells(1, ctr) = formula1
 ctr = ctr + 1: .Cells(1, ctr) = formula2
 ctr = ctr + 1: .Cells(1, ctr) = formula3
End With

Columns("E:F").EntireColumn.AutoFit
Columns("G").ColumnWidth = 13
Rows(1).EntireRow.AutoFit
Range("A1").Select

End Sub


Sub ListFormatConditions()
'use this to count and list conditions
'it will add a sheet or use existing one with your permission

'disclaimer/instructions
If MsgBox("This only works with formula conditions. " & _
"To capture them all, move other types (Highlight Cells, " & _
"Data Bars, etc.) lower in the Rules Manager (Alt-H,L,R)", _
vbOKCancel + vbDefaultButton2, "List Format Conditions") = vbCancel Then Exit Sub

Dim Wb As Workbook, Ws, WsFC As Worksheet
Dim col, ctr, Fcct, WsFcct, tblRows As Integer, WsnStr As String
Dim fcs As FormatConditions, fc As FormatCondition
Dim WsN, HdrArr As Variant, HdrsMatch, HasWsFC As Boolean

Application.ScreenUpdating = False
On Error Resume Next
HdrArr = Array("Sheet", "Priority", "Type", "Formula", "Fill color", _
"Pattern", "Font color", "Number format", "Applies to")

WsnStr = "Sheet" & vbTab & vbTab & "Conditions" & vbCr & _
        "-----" & vbTab & vbTab & "----------" & vbCr
'count all conditions in workbook and exit if none
Set Wb = ActiveWorkbook
For Each Ws In Wb.Worksheets
  If Ws.Name = "FormatConditions" Then HasWsFC = True
  WsFcct = Ws.Cells.FormatConditions.Count
  If WsFcct > 0 Then
    WsnStr = WsnStr & Ws.Name & vbTab & IIf(Len(Ws.Name) < 10, vbTab, "") & WsFcct & vbCr
    Fcct = Fcct + WsFcct
  End If
Next
If Fcct = 0 Then
  MsgBox "No format conditions found", , "List Format Conditions": Exit Sub
Else
  MsgBox WsnStr, , "List Format Conditions"
End If

'if sheet exists then select else add
If HasWsFC Then
  Set WsFC = Wb.Worksheets("FormatConditions")
  WsFC.Select
Else: GoTo AddSheet: End If

AskUpdate:
Select Case MsgBox("New sheet?" & vbCr & _
"Yes=create new one (manage names manually)." & vbCr & _
"No=clear and refill this sheet.", _
vbYesNoCancel + vbQuestion + vbDefaultButton2, "Update Sheet")
 Case vbYes: GoTo AddSheet
 Case vbNo: GoTo UpdateSheet
 Case vbCancel: Exit Sub
End Select

UpdateSheet:
'clear sheet and refill
Columns("A:Z").Delete
GoTo SetHeaders

AddSheet:
'add sheet at end
ActiveWorkbook.Worksheets.Add After:=Sheets(Sheets.Count)

SetHeaders:
'set up table headers
With ActiveSheet
.Name = "FormatConditions"
For ctr = 0 To UBound(HdrArr)
  .Cells(1, ctr + 1) = HdrArr(ctr)
Next
End With

'fill data
FillData:
Wb.Worksheets("FormatConditions").Range("A2").Select

On Error Resume Next
For Each Ws In Wb.Worksheets
Set fcs = Ws.Cells.FormatConditions
If fcs.Count = 0 Then GoTo Nextws
For Each fc In fcs
ctr = 0
With Selection
ctr = ctr + 1: .Cells(1, ctr) = Ws.Name
ctr = ctr + 1: .Cells(1, ctr) = fc.Priority
ctr = ctr + 1: .Cells(1, ctr) = fc.Type
ctr = ctr + 1: .Cells(1, ctr) = "'" & fc.formula1
ctr = ctr + 1: With .Cells(1, ctr)
  .Value = fc.Interior.Color
  If .Value > 0 Then .Interior.Color = .Value
  End With
ctr = ctr + 1: With .Cells(1, ctr)
  .Value = fc.Interior.Pattern
  .Interior.Pattern = fc.Interior.Pattern
  .Interior.PatternColor = fc.Interior.PatternColor
  If .Value = 4000 Then
  With .Interior.Gradient
    .ColorStops(1).Color = fc.Interior.Gradient.ColorStops(1).Color
    .ColorStops(2).Color = fc.Interior.Gradient.ColorStops(2).Color
    .Degree = fc.Interior.Gradient.Degree
  End With
  End If
  End With
ctr = ctr + 1: With .Cells(1, ctr)
  .Value = fc.Font.Color
  .Font.Color = .Value: End With
ctr = ctr + 1: .Cells(1, ctr) = fc.NumberFormat
ctr = ctr + 1: .Cells(1, ctr) = fc.AppliesTo.Address
.Offset(1, 0).Select
End With
Next fc
Nextws:
Next Ws

FormatTable:
'format the table
Range("A1").Select
Selection.CurrentRegion.Select
WsFC.ListObjects.Add(xlSrcRange, Selection, , xlYes, , _
"TableStyleLight9").Name = "ListFCs"
Columns("A:I").EntireColumn.AutoFit
With Columns("D:D")
  .ColumnWidth = WorksheetFunction.Min(.ColumnWidth, 80)
End With
With Selection
  .VerticalAlignment = xlTop
  .WrapText = True
  tblRows = .Rows.Count
End With
If tblRows < Fcct Then MsgBox Fcct - tblRows & _
" conditions could not be listed", , "List Format Conditions"
Range("A1").Select

End Sub

Sub RecordColors()
'use this to retrieve decimal and RGB values for a column of colors

Dim r, g, b, dec As Long, c As Range
'prompt
If MsgBox("This will record the color decimal and RGB values, " & vbCr & _
  "and fill another column by RGB as proof." & vbCr & vbCr & _
  "Select a single column of colored cells with 5 blank " & vbCr & _
  "columns to the right of it, and a blank row above it.", vbOKCancel + vbDefaultButton2, _
  "Record Colors") = vbCancel Then Exit Sub
Const hex2 = 16 ^ 2: Const hex4 = 16 ^ 4
'header
With ActiveCell
 .Offset(-1, 0) = "color": .Offset(-1, 1) = "decimal": .Offset(-1, 2) = "R":
 .Offset(-1, 3) = "G": .Offset(-1, 4) = "B": .Offset(-1, 5) = "RGB"
End With
'table
For Each c In Selection.Cells: With c
  dec = .Interior.Color
  r = dec Mod hex2
  g = Int((dec Mod hex4) / hex2)
  b = Int(dec / hex4)
  .Offset(0, 1) = dec: .Offset(0, 2) = r: .Offset(0, 3) = g
  .Offset(0, 4) = b: .Offset(0, 5).Interior.Color = RGB(r, g, b)
 End With
Next c
End Sub


