VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "Sheet2"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = True
Option Explicit
Option Base 1

'SECTIONS:
'### NAVIGATION SUBS
'### CARD SUBS
'### DEAL SUBS

'### NAVIGATION SUBS

Public Sub ShowDeckZone()
'called by click on the "dealt/remaining" deck image
With ActiveWindow
  .ScrollRow = [DeckZone].Row - 1
  .ScrollColumn = [DeckZone].Column - 1
End With
[NextCard].Select
End Sub

Public Sub ShowScoreBoard()
'called by click on the counting image
With ActiveWindow
  .ScrollRow = [ScoreRow].Row - 3
  .ScrollColumn = [ScoreRow].Column - 1
End With
[BackScore].Select
End Sub

Public Sub ShowScoreChart()
'called by click on the counting image
With ActiveWindow
  .ScrollRow = [ChartAnchor].Row - 2
  .ScrollColumn = [ChartAnchor].Column - 1
End With
[ChartAnchor].Select
End Sub

Public Sub Back()
'called by back button in deal help range
    Range("A1").Select
    [Dealer].Select
End Sub

Sub OpenRows1()
'called by transparent shape on top of folder icon
'toggles expand/collapse row group
If [RowGrp1].Rows.Hidden Then
    [RowGrp1].Rows.Hidden = False
    [RowSet1].Value = Chr(49)
Else
    [RowGrp1].Rows.Hidden = True
    [RowSet1].Value = Chr(48)
End If
End Sub

Sub OpenRows2()
'called by transparent shape on top of folder icon
'toggles expand/collapse row group
If [RowGrp2].Rows.Hidden Then
    [RowGrp2].Rows.Hidden = False
    [RowSet2].Value = Chr(49)
Else
    [RowGrp2].Rows.Hidden = True
    [RowSet2].Value = Chr(48)
End If
End Sub

Sub ShowDeck()
'called by click on card icon in row 1
'toggles "dealt/remaining" deck image visibility

With ActiveSheet.Shapes.Range(Array("DeckImage"))
  .Visible = Not .Visible
End With

End Sub

'### CARD SUBS

' called by each card click; toggles hold
Sub CardClick(Card As Integer)
Dim HoldCell As String
HoldCell = "Hold" & Card
On Error Resume Next
With Range(HoldCell)
    .Value = Not .Value
End With
[Dealer].Select
[HoldControls].Calculate
End Sub

'each Click below is a transparent rectangle on a card
Sub Player1Card1_Click()
CardClick (11)
End Sub

Sub Player1Card2_Click()
CardClick (12)
End Sub

Sub Player1Card3_Click()
CardClick (13)
End Sub

Sub Player1Card4_Click()
CardClick (14)
End Sub

Sub Player1Card5_Click()
CardClick (15)
End Sub

Sub Player2Card1_Click()
CardClick (21)
End Sub

Sub Player2Card2_Click()
CardClick (22)
End Sub

Sub Player2Card3_Click()
CardClick (23)
End Sub

Sub Player2Card4_Click()
CardClick (24)
End Sub

Sub Player2Card5_Click()
CardClick (25)
End Sub

Sub HoldPlayer(Player As Integer, State As Boolean)
'called by other subs to set or unset all holds either Player
Dim c As Range, holds As String
holds = "holds" & Player
For Each c In Range(holds).Cells
c = State
Next c
End Sub

Sub HoldPlayer1()
'called by transparent rectangle on top of small circle in corner of Player
With [CountHolds1]: .Calculate
  Select Case .Value
    Case 0 To 4
      Call HoldPlayer(1, True)
    Case 5
      Call HoldPlayer(1, False)
  End Select
End With
[HoldControls].Calculate
End Sub

Sub HoldPlayer2()
'called by transparent rectangle on top of small circle in corner of Player
With [CountHolds2]: .Calculate
  Select Case .Value
    Case 0 To 4
      Call HoldPlayer(2, True)
    Case 5
      Call HoldPlayer(2, False)
  End Select
End With
[HoldControls].Calculate
End Sub

'### DEAL SUBS

Sub DealButton()
'called by deal button
Dim ch1, ch2, dc, r As Integer
[HoldControls].Calculate
ch1 = [CountHolds1]
ch2 = [CountHolds2]
dc = [DealCount]
'Application.ScreenUpdating = False

Select Case dc  'deal count
  Case 0        'at start of new hand, reset all
    [showhand].Value = False: Range("Dealt[Dealt]").ClearContents
    Call HoldPlayer(1, False): Call HoldPlayer(2, False)
    [Player1].ClearContents: [Player2].ClearContents
    ActiveSheet.Calculate
  Case Else     'for subsequent deals check holds
                'if Player1 has some holds and Player2 none then set Player2 and redeal
    If ch1 > 0 And ch1 < 5 And ch2 = 0 Then Call HoldPlayer(2, True): GoTo NextPt
                'if Player2 has some holds and Player1 none then set Player1 and redeal
    If ch2 > 0 And ch2 < 5 And ch1 = 0 Then Call HoldPlayer(1, True): GoTo NextPt
                'if both none or both all then end hand
    If ch1 * ch2 = 0 Or ch1 * ch2 = 25 Then GoTo EndPt
End Select

NextPt:         'deal, and increment DealCount
Deal (dc)
With [DealCount]
  .Value = .Value + 1
  If .Value > 2 Then GoTo EndPt
End With
GoTo Out

EndPt:          'call end of hand when holds all or none
EndHand         'or after last deal

Out:            'cleanup
ActiveSheet.Calculate
With Application
  .CutCopyMode = False
  .ScreenUpdating = True
End With
End Sub

Sub Deal(dc As Integer)
' called by DealButton sub
Dim Player, CardNum As Integer
Dim Calc, Hold, Card As String
Application.ScreenUpdating = False

Select Case dc            'dc passes deal count
  Case 0                  'on first deal, deal by card then by player
    For CardNum = 1 To 5
    For Player = 1 To 2
      Card = "Card" & Player & CardNum
        [Deck].Calculate  'refresh Deck = "not dealt"
        With [NextCard]   'refresh NextCard = random pick of Deck
          .Calculate      '(like shuffle)
          .Copy           'copy the random card
        End With
                          'paste random card to card cell
        Range(Card).PasteSpecial (xlPasteValues)
                          'find first empty cell in Dealt and paste same card
        Range("Dealt[[#Headers],[Dealt]]").Select
        If Len(Selection.Offset(1, 0)) > 0 Then Selection.End(xlDown).Select
        Selection.Offset(1, 0).PasteSpecial Paste:=xlPasteValues
    Next Player           'alternate players
    Next CardNum          'repeat for each of 5 cards
 
  Case Else               'after first deal, deal by player then by card
    For Player = 1 To 2
    For CardNum = 1 To 5
      Hold = "Hold" & Player & CardNum
      Card = "Card" & Player & CardNum
      If Not Range(Hold) Then   ' skip if Hold cell is true
        [Deck].Calculate  'same as first deal
        With [NextCard]   '...
          .Calculate      '...
          .Copy           '...
        End With
        Range(Card).PasteSpecial (xlPasteValues)
        Range("Dealt[[#Headers],[Dealt]]").Select
        If Len(Selection.Offset(1, 0)) > 0 Then Selection.End(xlDown).Select
        Selection.Offset(1, 0).PasteSpecial Paste:=xlPasteValues
      End If
    Next CardNum          'next unheld card
    Next Player           'next plyr
End Select

Application.CutCopyMode = False
[Dealer].Select

End Sub

Sub EndHand()
'called by DealButton sub
Application.ScreenUpdating = False

Call HoldPlayer(1, True)          'hold all
Call HoldPlayer(2, True)
Range("DealCount").Value = 0    'reset DealCount
Range("ShowHand").Value = True  'reset ShowHand
ActiveSheet.Calculate
RecordScore
Application.ScreenUpdating = True
[Dealer].Select

End Sub

Private Sub Worksheet_Activate()
Application.Calculation = xlManual

End Sub

Sub RecordScore()
'called by EndHand
Dim tbl As ListObject, lc As ListColumn, lr As ListRow, Card As String
If Not [recordflag] Then Exit Sub
Set tbl = ActiveSheet.ListObjects("PokerScores")
Set lr = tbl.ListRows.Add(1)
With [ScoreRow]
  .Calculate
  .Copy
End With
lr.Range(1, 1).PasteSpecial Paste:=xlPasteValues
Application.CutCopyMode = False

End Sub
