VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "Sheet5"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = True
Option Explicit

Private Sub Worksheet_SelectionChange(ByVal Target As Range)
Dim overlap As Range, msg As String, Game1Over As Boolean
  'if switched off then do nothing
If [stopflag] Then Exit Sub
Set overlap = Application.Intersect(Target, [zone])
On Error Resume Next

With Target
  'in case entire sheet selected
If .Cells.Count > [zone].Cells.Count Then Exit Sub
  'target must be completely within the zone
If .Address <> overlap.Address Then Exit Sub
  'snake game does not allow extend mode (stop, not end)
If [game1] And .Cells.Count > 1 Then GoTo Game1Stop
  'snake game if target already filled then game over
If [game1] And Len(.Value) > 0 Then Game1Over = True
  'move or extend right (extend does not change selection column)
If .Column > [colnum] Or (.Column = [colnum] And _
    .Columns.Count > [colcount]) Then
    .Value = [symR]
  'move or extend left (extend changes selection column)
ElseIf .Column < [colnum] Then
    .Value = [symL]
  'move or extend down (extend does not change selection row)
ElseIf .Row > [rownum] Or (.Row = [rownum] And _
    .Rows.Count > [RowCount]) Then
    .Value = [symD]
  'move or extend up (extend changes selection row)
ElseIf .Row < [rownum] Then
    .Value = [symU]
End If
  'set counter cells
[colnum] = .Column
[colcount] = .Columns.Count
[rownum] = .Row
[RowCount] = .Rows.Count
End With
ActiveSheet.Calculate
GoTo Game1End

Game1Stop:
MsgBox "Use arrow keys or mouse to move one cell at a time.", _
vbInformation + vbOKOnly, "Game 1"
Exit Sub

Game1End:
If Not [game1] Then GoTo Game2End
If Game1Over Then
  'game over message with count and % of cells filled
  MsgBox "Game over. You covered " & [symcount] & " of " & [zone].Cells.Count & " cells = " & _
  Int(100 * [symcount] / [zone].Cells.Count) & "%", vbExclamation + vbOKOnly, "Game Over"
  ClearZone
End If
Exit Sub

Game2End:
If Not [game2] Then Exit Sub
If [symcount] = [zone].Cells.Count Then
  'game over message with % balance score
  MsgBox "Game over. You achieved a balance score of " & _
  Int(100 * ([symcount] - [symrange]) / [symcount]) & "%", _
  vbExclamation + vbOKOnly, "Game Over"
  ClearZone
End If
End Sub

Sub ClearZone()
'click trash icon
[zone].ClearContents
ActiveSheet.Calculate
End Sub

Sub Switch()
'click switch icon
With [stopflag]: .Value = Not .Value: End With
ActiveSheet.Calculate
End Sub

Sub SelectGame1()
'click puzzle icon
With [game1]: .Value = Not .Value: End With
If [game1].Value Then [game2].Value = False: ClearZone
ActiveSheet.Calculate
End Sub

Sub SelectGame2()
'click balance icon
With [game2]: .Value = Not .Value: End With: ClearZone
If [game2].Value Then [game1].Value = False
ActiveSheet.Calculate
End Sub

Private Sub Worksheet_Activate()
Application.Calculation = xlManual

End Sub
